from axipy import Table


def getStringFields(tab:Table,limit_size=36):
    names_str_att=[]
    for att in tab.schema:
        if att.type_string!="string":
            continue
        if att.length<limit_size:
            continue
        names_str_att.append(att.name)
    if len(names_str_att)==0:
        return None
    return names_str_att
class CalcIntProcent:
    def __init__(self,count):
        self.__last_proc=-1
        self.__count=count
    def getValue(self,curent):
        cur_val=int((curent/self.__count)*100+0.5)
        if cur_val==self.__last_proc:
            return None
        self.__last_proc=cur_val
        return cur_val
class TableCache:
    def __init__(self,tab,size_cache=200):
        self.__tab=tab
        self.__cache_ft=[]
        self.__size_cache=size_cache
    def add(self,ft):
        if len(self.__cache_ft)>self.__size_cache:
            self.__save()
            self.__cache_ft.clear()
        self.__cache_ft.append(ft)
    def end(self):
        if len(self.__cache_ft)>0:
            self.__save()

    def __save(self):
        self.__tab.update(self.__cache_ft)
