import axipy

from FillFieldGUID.ui.add_helper.tab_helper import getStringFields


def factoryObserver(name_observer):
    observer=axipy.observer_manager.get(name_observer)
    if observer is None:
        observer=axipy.Observer(name_observer,False)
    def addTable(name_tab):
        if observer.value:
            return
        tab=axipy.data_manager.find(name_tab)
        att_string=getStringFields(tab)
        if len(att_string)==0:
            return
        observer.value=True

    def removedTable(name_table):
        tabs=axipy.data_manager.tables
        if len(tabs)==0:
            observer.value=False
            return
        for tab in tabs:
            if tab.name==name_table:
                continue
            addTable(tab.name)
            if observer.value:
                return
        observer.value = False
        return

    setattr(observer, "addTable", addTable)
    setattr(observer, "removedTable", removedTable)
    axipy.data_manager.added.connect(addTable)
    axipy.data_manager.removed.connect(removedTable)
    removedTable(None)
    return observer